routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return redirect('/home');
});

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');
Route::get('/play', 'PlayController@index')->name('play');
Route::get('/join', 'JoinController@index')->name('join');
Route::get('/privacy', 'GdprController@index')->name('privacy');
Route::get('/search', 'SearchController@index')->name('search.index');

Route::resource('albums', 'AlbumController');
Route::resource('artists', 'ArtistController');
Route::resource('songs', 'SongController');
Route::get('/{type}/{id}/playlist', 'PlaylistController@addToPlaylist')->name('playlist.addToPlaylist');
Route::put('/{type}/{id}/playlist', 'PlaylistController@addToPlaylist')->name('playlist.addToPlaylist');

Route::post('/songs/{id}/queue', 'SongController@enqueue')->name('songs.enqueue');
Route::delete('/songs/{id}/queue', 'SongController@dequeue')->name('songs.dequeue');
Route::delete('/queue', 'SongController@emptySession')->name('songs.flush');

Route::resource('playlists', 'PlaylistController');


Route::resource('profile', 'ProfileController', [
    'only' => ['edit', 'update', 'destroy'],
    'parameters' => ['profile' => 'user']
]);
Route::put('/profile/{id}/theme', 'ProfileController@updateTheme')->name('profile.updateTheme');

/**
 * Redirection
 */
Route::any('{query}', function () {
    return redirect('/home');
})->where('query', '.*');

app/Playlist.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Playlist extends Model
{
    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'visibility', 'user_id'
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
    ];

    public function songs()
    {
        return $this->belongsToMany('App\Song');
    }

    public function getSongIdsAttribute()
    {
        return $this->songs->pluck('id');
    }
}

app/Http/Controllers/ArtistController.php
<?php

namespace App\Http\Controllers;

use App\Artist;
use App\Repositories\ArtistRepository;
use Illuminate\Http\Request;
use Illuminate\Http\Response;
use Illuminate\Support\Facades\Auth;

class ArtistController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @param ArtistRepository $artistRepository
     * @param Request $request
     * @return Response
     */
    public function index(ArtistRepository $artistRepository, Request $request)
    {
        $q = null;

        if ($request->has('q')) {
            $validatedData = $request->validate([
                'q' => 'required|string'
            ]);

            $q = $validatedData['q'];
        }

        if (Auth::check()) {
            $artists = isset($q) ? $artistRepository->searchArtists($q, Auth::user()->id) : $artistRepository->getArtists(Auth::user()->id);
        } else {
            $artists = isset($q) ? $artistRepository->searchArtists($q) : $artistRepository->getArtists();
        }
        return view('artists.listing_artists', compact('artists'));
    }

    public function show(Artist $artist)
    {
        if (Auth::check()) {
            $songs = $artist->songs()->where('songs.visibility', 'public')->orWhere('songs.visibility', 'private')->
            where('songs.user_id', Auth::user()->id)->where('songs.artist_id', $artist->id)->orderBy('songs.title', 'ASC')->paginate(3);
        } else {
            $songs = $artist->songs()->where('songs.visibility', 'public')->where('songs.artist_id', $artist->id)->orderBy('songs.title', 'ASC')->paginate(3);
        }

        $albums = $artist->albums()->withCount('songs')->where('albums.artist_id', $artist->id)->paginate(3, ['*'], 'album_pagination');
        return view('artists.show_artist', compact('artist', 'songs', 'albums'));
    }
}

app/Http/Controllers/PlaylistController.php
<?php

namespace App\Http\Controllers;

use App\Album;
use App\Artist;
use App\Playlist;
use App\Repositories\PlaylistRepository;
use App\Song;
use Exception;
use Illuminate\Http\Request;
use Illuminate\Http\Response;
use Illuminate\Support\Facades\Auth;
use Illuminate\Validation\Rule;

class PlaylistController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @param PlaylistRepository $playlistRepository
     * @param Request $request
     * @return Response
     */
    public function index(PlaylistRepository $playlistRepository, Request $request)
    {
        $q = null;

        if ($request->has('q')) {
            $validatedData = $request->validate([
                'q' => 'required|string'
            ]);

            $q = $validatedData['q'];
        }

        if (Auth::check()) {
            $playlists = isset($q) ? $playlistRepository->searchPrivatePlaylist($q, Auth::user()->id) : $playlistRepository->getWithUser(Auth::user()->id);
            $public_playlists = isset($q) ? $playlistRepository->searchPublicPlaylist($q) : $playlistRepository->getPublic();
            return view('playlists.listing_playlists', compact('playlists', 'public_playlists'));
        } else {
            $public_playlists = isset($q) ? $playlistRepository->searchPublicPlaylist($q) : $playlistRepository->getPublic();
            return view('playlists.listing_playlists', compact('public_playlists'));
        }
    }

    public function addToPlaylist($type, $id, PlaylistRepository $playlistRepository, Request $request)
    {

        if (Auth::check()) {
            switch ($type) {
                case 'song':
                    /** @var Song $model */
                    $model = Song::findOrFail($id);
                    break;
                case 'artist':
                    /** @var Artist $model */
                $model = Artist::findOrFail($id);
                    break;
                case 'album':
                    /** @var Album $model */
                $model = Album::findOrFail($id);
                    break;
                default:
                    abort(400);
            }

            if ($request->isMethod('get')) {
                $playlists = $playlistRepository->getWithUser(Auth::user()->id);

                if (Auth::user()->type_user === 'admin') {
                    $public_playlists = $playlistRepository->getPublic();
                    return view('partials.add_generic_to_playlist', compact('model', 'playlists', 'public_playlists', 'type'));
                }

                return view('partials.add_generic_to_playlist', compact('model', 'playlists', 'type'));
            } else {
                $validatedData = $request->validate([
                    'playlist_id' => 'required|array',
                    'action' => ['required', 'string', Rule::in(['add', 'delete'])]
                ]);

                $action = $validatedData['action'];

                if($type === 'artist' || $type === 'album'){
                    foreach ($model->songs as $song) {
                        foreach ($validatedData['playlist_id'] as $id) {
                            /** @var $playlist Playlist */
                            $playlist = Playlist::find($id);
                            if ($action == 'add') {
                                $playlist->songs()->syncWithoutDetaching([$song->id]);
                            } else {
                                $playlist->songs()->detach($song->id);
                            }
                        }
                    }
                } else {
                    foreach ($validatedData['playlist_id'] as $id) {
                        /** @var $playlist Playlist */
                        $playlist = Playlist::find($id);
                        if ($action == 'add') {
                            $playlist->songs()->syncWithoutDetaching([$model->id]);
                        } else {
                            $playlist->songs()->detach($model->id);
                        }
                    }
                }

                if ($action == 'add') {
                    return redirect()->back()->with('message', 'Song added to playlist');
                } else {
                    return response()->json(['type' => 'success', 'message' => 'Song removed from playlist']);
                }

            }
        } else {
            abort(403);
        }
    }

    public function show(Playlist $playlist)
    {
        return view('playlists.show_playlist', compact('playlist'));
    }


    public function edit(Playlist $playlist)
    {
        return view('playlists.edit_playlist', compact('playlist'));
    }

    public function update(Request $request, $id)
    {
        $validatedData = $request->validate([
            'name' => 'required|string|',
            'visibility' => ['required', 'string', Rule::in(['public', 'private'])]
        ]);

        if (Auth::user()->type_user !== 'admin' && $validatedData['visibility'] === 'public') {
            return redirect()->back()->withErrors(['This user can\'t define public playlists.']);
        }

        Playlist::find($id)->update($validatedData);
        return redirect()->back()->with('message', 'Playlist updated');
    }

    public function create(Request $request)
    {
        $validatedData = $request->validate([
            'visibility' => ['required', 'string', Rule::in(['public', 'private'])]
        ]);
        $visibility = $validatedData['visibility'];
        return view('playlists.add_playlist', compact('visibility'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param Request $request
     * @param PlaylistRepository $playlistRepository
     * @return Response
     */
    public function store(Request $request, PlaylistRepository $playlistRepository)
    {
        $validatedData = $request->validate([
            'name' => 'required|string',
            'visibility' => ['required', 'string', Rule::in(['public', 'private'])]
        ]);

        $validatedData['user_id'] = Auth::user()->id;

        $playlist = $playlistRepository->store($validatedData);
        return view('playlists.edit_playlist', compact('playlist'));
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param Playlist $playlist
     * @return void
     * @throws Exception
     */
    public function destroy(Playlist $playlist)
    {
        $playlist->delete();
        return response()->json(['type' => 'success', 'message' => 'Playlist deleted']);
    }
}

resources/views/playlists/add_playlist.blade.php
@extends('partials.iframe-tab')
@section('tab')
    <div class="row justify-content-center">
        <div class="col-md-12 mt-2">
            @if(session()->has('message'))
                <div class="alert alert-success alert-dismissable">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                    {{ session()->get('message') }}
                </div>
            @endif
            @if($errors->any())
                <div class="alert alert-danger alert-dismissable">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                    {{ $errors->first() }}
                </div>
            @endif
            <form action="{{ route('playlists.store')}}" method="POST">
                @csrf

                <div class="d-flex">
                    <div class="media-body">
                        <a href="{{route('playlists.index')}}" class="btn"><i>@svg('solid/angle-left',
                                'icon-white')</i></a>
                    </div>
                    <div class="align-self-center">
                        <input type="text" class="h3 m-0 bg-transparent border-0 text-white no-outline"
                               name="name" placeholder="Playlist name"
                               value="{{ old('name') }}" autofocus>

                        @if ($errors->has('name'))
                            <span class="invalid-feedback" role="alert">
                                        <strong>{{ $errors->first('name') }}</strong>
                                    </span>
                        @endif
                    </div>
                    <div class="media-body"></div>
                </div>

                @admin
                <div class="d-block">
                    <label>{{ __('Visibility') }}</label>
                    <div class="d-block">
                        <div class="custom-control custom-radio custom-control-inline">
                            <input type="radio" id="private_playlist" name="visibility"
                                   class="custom-control-input"
                                   value="private"
                                   @if(old('visibility') == 'private' || $visibility === 'private') checked @endif>
                            <label class="custom-control-label" for="private_playlist">{{__('Private')}}</label>
                        </div>
                        <div class="custom-control custom-radio custom-control-inline">
                            <input type="radio" id="public_playlist" name="visibility"
                                   class="custom-control-input"
                                   value="public"
                                   @if(old('visibility') === 'public' || $visibility === 'public') checked @endif>
                            <label class="custom-control-label" for="public_playlist">{{__('Public')}}</label>
                        </div>
                    </div>
                </div>
                @else
                    <input type="hidden" value="private" name="visibility">
                    @endadmin

                    <button type="submit" class="btn btn-impulsy btn-block mt-3">{{ __('Save') }}</button>
            </form>
        </div>
    </div>
@endsection
@section('scripts')

@endsection

resources/views/playlists/edit_playlist.blade.php
@extends('partials.iframe-tab')
@section('tab')
    <div class="row justify-content-center">
        <div class="col-md-12 mt-2">
            @if(session()->has('message'))
                <div class="alert alert-success alert-dismissable">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                    {{ session()->get('message') }}
                </div>
            @endif
            @if($errors->any())
                <div class="alert alert-danger alert-dismissable">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                    {{ $errors->first() }}
                </div>
            @endif
            <form action="{{ route('playlists.update', $playlist->id)}}" method="POST">
                @method('PUT')
                @csrf

                <div class="d-flex">
                    <div class="media-body">
                        <a href="{{route('playlists.index')}}" class="btn"><i>@svg('solid/angle-left',
                                'icon-white')</i></a>
                    </div>
                    <div class="align-self-center">
                        <input type="text" class="h3 m-0 bg-transparent border-0 text-white no-outline"
                               name="name"
                               value="{{$playlist->name}}">
                    </div>
                    <div class="media-body"></div>
                </div>

                @admin
                <div class="d-block">
                    <label>{{ __('Visibility') }}</label>
                    <div class="d-block">
                        <div class="custom-control custom-radio custom-control-inline">
                            <input type="radio" id="public_playlist" name="visibility"
                                   class="custom-control-input"
                                   value="public"
                                   @if(old('visibility', $playlist->visibility) == "public") checked @endif>
                            <label class="custom-control-label" for="public_playlist">{{__('Public')}}</label>
                        </div>
                        <div class="custom-control custom-radio custom-control-inline">
                            <input type="radio" id="private_playlist" name="visibility"
                                   class="custom-control-input"
                                   value="private"
                                   @if(old('visibility', $playlist->visibility) == "private") checked @endif>
                            <label class="custom-control-label" for="private_playlist">{{__('Private')}}</label>
                        </div>
                    </div>
                </div>
                @else
                    <input type="hidden" value="private" name="visibility">
                @endadmin

                <div class="form-group row">
                    <div class="col-6">
                        <button type="submit"
                                class="btn btn-impulsy btn-block mt-3">{{ __('Save changes') }}</button>
                    </div>
                    <div class="col-6">
{{--                        <button type="button" class="btn btn-impulsy btn-block mt-3">{{ __('Add song') }}</button>--}}
                    </div>
                </div>
            </form>

            <ul class="list-unstyled mt-3">
                @foreach($playlist->songs as $song)
                    <li id="song_{{$song->id}}" class="media bg-transparent mb-2">
                        <i class="mr-3">@svg('list_title','icon-xl icon-pink')</i>
                        <div class="media-body">
                            <div class="float-right">
                                <div class="dropdown d-inline">
                                    <a id="addDropdown" href="#" role="button"
                                       data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                        <i class="mr-3">@svg('solid/plus', 'icon-sm icon-white')</i>
                                    </a>

                                    <div class="dropdown-menu dropdown-menu-right" aria-labelledby="addDropdown">
                                        <a class="dropdown-item" href="#"
                                           onclick="enqueue({{ json_encode(route('songs.enqueue', $song->id)) }})">
                                            {{ __('Add to queue') }}
                                        </a>

                                        @auth
                                            <a class="dropdown-item" href="#modalForm"
                                               data-href="{{route('playlist.addToPlaylist', ['type' => 'song', $song->id])}}"
                                               data-toggle="modal">
                                                {{ __('Add to playlist') }}
                                            </a>
                                        @endauth
                                    </div>
                                </div>
                                <form id="removeSong_{{$song->id}}"
                                      action="{{ route('playlist.addToPlaylist', ['type' => 'song', $song->id])}}"
                                      class="form-inline float-right" method="POST">
                                    @method('PUT')
                                    @csrf
                                    <input type="hidden" value="{{$playlist->id}}" name="playlist_id[]">
                                    <input type="hidden" value="delete" name="action">
                                    <a onclick="submit({{$song->id}});" class="cursor-pointer">
                                        <i>@svg('solid/times', 'icon-sm icon-white')</i>
                                    </a>
                                </form>
                            </div>
                            <a class="cursor-pointer" id="{{json_encode($song->id)}}_play"
                               onclick="play({{ json_encode(route('songs.enqueue', $song->id)) }})">
                                <h5 class="mt-0 mb-1 font-weight-bolder">{{ $song->title }}</h5>
                            </a>
                            {{ $song->artist->name ?? "Unknown Artist" }}
                        </div>
                    </li>
                @endforeach
            </ul>
        </div>
    </div>
@endsection
@section('scripts')
    <script>
        function submit(id) {
            let form = $("#removeSong_" + id);
            let url = form.attr('action');
            $.ajax({
                type: "PUT",
                url: url,
                data: form.serialize(),
                success: function (data) {
                    $('#song_' + id).remove();
                }
            });
        }
    </script>
@endsection

resources/views/playlists/listing_playlists.blade.php
@extends('partials.iframe-tab')
@section('tab')
    <div class="row justify-content-center">
        <div class="col-md-12 mt-2">
            <div>
                <div class="title-group">
                    <h2 class="d-inline text-pink">{{ __('Playlists') }}</h2>
                </div>
                @auth
                    <a href="{{ route('playlists.create', ['visibility' => 'private']) }}">
                        <input type="button" class="btn btn-impulsy btn-block mt-3"
                               value="{{ __('Add') }}">
                    </a>

                    <div class="mt-3">
                        <div class="title-group p-3 bg-h3 rounded cursor-pointer" data-toggle="collapse"
                             data-target="#collapsePrivatePlaylists"
                             aria-expanded="true">
                            <h3 class="d-inline">{{ __('Your Playlists') }}</h3>
                            <i class="float-right">@svg('solid/angle-down', 'icon-white')</i>
                        </div>

                        <div class="collapse show" id="collapsePrivatePlaylists">
                            <ul class="list-unstyled mt-3">
                                @foreach($playlists as $playlist)
                                    <li class="media bg-transparent mb-2">
                                        <i class="mr-3">@svg('list_music','icon-xl icon-pink')</i>
                                        <div class="media-body">
                                            <div class="float-right">
                                                <div class="dropdown d-inline">
                                                    <a id="addDropdown" href="#" role="button"
                                                       data-toggle="dropdown" aria-haspopup="true"
                                                       aria-expanded="false">
                                                        <i class="mr-3">@svg('solid/plus', 'icon-sm icon-white')</i>
                                                    </a>

                                                    <div class="dropdown-menu dropdown-menu-right"
                                                         aria-labelledby="addDropdown">
                                                        <a class="dropdown-item" href="#"
                                                           onclick="queue({{json_encode($playlist->getSongIdsAttribute())}})">
                                                            {{ __('Add to queue') }}
                                                        </a>
                                                    </div>
                                                </div>
                                                <a href="#"
                                                   onclick="playAll({{json_encode($playlist->getSongIdsAttribute())}})">
                                                    <i class="mr-3">@svg('solid/play', 'icon-sm icon-white')</i>
                                                </a>
                                                <a class="delete"
                                                   href="{{ route('playlists.destroy', $playlist->id) }}">
                                                    <i>@svg('solid/times', 'icon-sm icon-white')</i>
                                                </a>
                                            </div>
                                            <a href="{{ route('playlists.edit', $playlist->id) }}">
                                                <h5 class="mt-0 mb-1 font-weight-bolder cursor-pointer text-decoration-none">{{ $playlist->name }}</h5>
                                            </a>
                                            {{ $playlist->songs_count }} {{ __('Titles') }}.
                                        </div>
                                    </li>
                                @endforeach
                            </ul>
                            <div
                                class="mt-2">{{ $playlists->appends(array_except(Request()->query(), 'private_pagination'))->links() }}</div>
                        </div>
                    </div>
                @endauth

                <div class="mt-3">
                    <div class="title-group p-3 bg-h3 rounded cursor-pointer" data-toggle="collapse"
                         data-target="#collapsePublicPlaylists"
                         aria-expanded="true">
                        <h3 class="d-inline">{{ __('Public Playlists') }}</h3>
                        <i class="float-right">@svg('solid/angle-down', 'icon-white')</i>
                    </div>

                    <div class="collapse show" id="collapsePublicPlaylists">
                        <ul class="list-unstyled mt-3">
                            @foreach($public_playlists as $playlist)
                                <li class="media bg-transparent mb-2">
                                    <i class="mr-3">@svg('list_music','icon-xl icon-pink')</i>
                                    <div class="media-body">
                                        <div class="float-right">
                                            <div class="dropdown d-inline">
                                                <a id="addDropdown" href="#" role="button"
                                                   data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                                    <i class="mr-3">@svg('solid/plus', 'icon-sm icon-white')</i>
                                                </a>

                                                <div class="dropdown-menu dropdown-menu-right"
                                                     aria-labelledby="addDropdown">
                                                    <a class="dropdown-item" href="#"
                                                       onclick="queue({{json_encode($playlist->getSongIdsAttribute())}})">
                                                        {{ __('Add to queue') }}
                                                    </a>
                                                </div>
                                            </div>
                                            <a href="#"
                                               onclick="playAll({{json_encode($playlist->getSongIdsAttribute())}})">
                                                <i class="mr-3">@svg('solid/play', 'icon-sm icon-white')</i>
                                            </a>
                                            @admin
                                            <a class="delete"
                                               href="{{ route('playlists.destroy', $playlist->id) }}">
                                                <i>@svg('solid/times', 'icon-sm icon-white')</i>
                                            </a>
                                            @endadmin
                                        </div>
                                        @admin
                                        <a href="{{ route('playlists.edit', $playlist->id) }}">
                                            <h5 class="mt-0 mb-1 font-weight-bolder cursor-pointer">{{ $playlist->name }}</h5>
                                        </a>
                                        @else
                                            <a href="{{ route('playlists.show', $playlist->id) }}">
                                                <h5 class="mt-0 mb-1 font-weight-bolder cursor-pointer">{{ $playlist->name }}</h5>
                                            </a>
                                            @endadmin
                                            {{ $playlist->songs_count }} {{ __('Titles') }}.
                                    </div>
                                </li>
                            @endforeach
                        </ul>
                        <div
                            class="mt-2">{{ $public_playlists->appends(array_except(Request()->query(), 'page'))->links() }}</div>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection
@section('scripts')

@endsection